package com.nisum.example.repository;

import com.nisum.example.dto.ProductDTO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.ReactiveMongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.data.mongodb.core.query.Update;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@Slf4j
public class CustomProductRepositoryImpl implements CustomProductRepository {

    @Autowired
    private ReactiveMongoTemplate reactiveMongoTemplate;

    //TODO result not as expected
    @Override
    public Mono<ProductDTO> changeProductPrice(String id, Double newPrice) {
        Query query=new Query(Criteria.where("prodId").is(id));
        Update update=new Update().set("prodPrice",newPrice);
        log.info("Calling findandModify()....");
        return reactiveMongoTemplate.findAndModify(query,update,ProductDTO.class);
    }

    @Override
    public Mono<Boolean> clearProductById(String id) {
        return reactiveMongoTemplate.remove(Query.query(Criteria.where("prodId").is(id)),
                ProductDTO.class)
                .flatMap(deleteResult -> Mono.just(deleteResult.wasAcknowledged()));
    }

    @Override
    public Flux<ProductDTO> pickProductByName(String prodName) {
        log.info("Calling template find()...");
        return reactiveMongoTemplate
                .find(Query.query(Criteria.where("prodName").is(prodName)),
                        ProductDTO.class);
    }
}
